/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999-2008 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s): Michel-Ange ANTON
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.service.container;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.objectweb.jonas.webapp.jonasadmin.Jlists;
import org.objectweb.jonas.webapp.jonasadmin.service.ModuleForm;

/**
 * @author Michel-Ange ANTON
 * @author S. Ali Tokmen, Malek Chahine: EJB statistics
 */
public class EjbContainersStatisticForm extends ActionForm {

// --------------------------------------------------------- Properties Variables

    private boolean monitoringEnabled = false;
    private int warningThreshold = 0;
    private String applySettingsTo = "none";
    private int totalCurrentNumberOfCMPType = 0;
    private int totalCurrentNumberOfSBFType = 0;
    private int currentNumberOfContainer = 0;
    private int totalCurrentNumberOfBMPType = 0;
    private int totalCurrentNumberOfMDBType = 0;
    private int totalCurrentNumberOfSBLType = 0;
    private int totalCurrentNumberOfBeanType = 0;
    
    private int numberOfCalls = 0;
    private long totalBusinessProcessingTime = 0;
    private long totalProcessingTime = 0;
    private long averageBusinessProcessingTime = 0;
    private long averageProcessingTime = 0;
    private boolean monitoringSettingsDefinedInDD = false;

// --------------------------------------------------------- Public Methods

    /**
     * Reset all properties to their default values.
     *
     * @param mapping The mapping used to select this instance
     * @param request The servlet request we are processing
     */

    public void reset(ActionMapping mapping, HttpServletRequest request) {
        totalCurrentNumberOfCMPType = 0;
        totalCurrentNumberOfSBFType = 0;
        currentNumberOfContainer = 0;
        totalCurrentNumberOfBMPType = 0;
        totalCurrentNumberOfMDBType = 0;
        totalCurrentNumberOfSBLType = 0;
        totalCurrentNumberOfBeanType = 0;
    }

    /**
     * Validate the properties that have been set from this HTTP request,
     * and return an <code>ActionErrors</code> object that encapsulates any
     * validation errors that have been found.  If no errors are found, return
     * <code>null</code> or an <code>ActionErrors</code> object with no
     * recorded error messages.
     *
     * @param mapping The mapping used to select this instance
     * @param request The servlet request we are processing
     */
    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
        ActionErrors oErrors = new ActionErrors();
        return oErrors;
    }

// --------------------------------------------------------- Properties Methods

    public int getTotalCurrentNumberOfCMPType() {
        return totalCurrentNumberOfCMPType;
    }

    public int getTotalCurrentNumberOfSBFType() {
        return totalCurrentNumberOfSBFType;
    }

    public int getCurrentNumberOfContainer() {
        return currentNumberOfContainer;
    }

    public int getTotalCurrentNumberOfBMPType() {
        return totalCurrentNumberOfBMPType;
    }

    public int getTotalCurrentNumberOfMDBType() {
        return totalCurrentNumberOfMDBType;
    }

    public int getTotalCurrentNumberOfSBLType() {
        return totalCurrentNumberOfSBLType;
    }

    public int getTotalCurrentNumberOfBeanType() {
        return totalCurrentNumberOfBeanType;
    }

    public void setTotalCurrentNumberOfCMPType(int totalCurrentNumberOfCMPType) {
        this.totalCurrentNumberOfCMPType = totalCurrentNumberOfCMPType;
    }

    public void setTotalCurrentNumberOfSBFType(int totalCurrentNumberOfSBFType) {
        this.totalCurrentNumberOfSBFType = totalCurrentNumberOfSBFType;
    }

    public void setCurrentNumberOfContainer(int currentNumberOfContainer) {
        this.currentNumberOfContainer = currentNumberOfContainer;
    }

    public void setTotalCurrentNumberOfBMPType(int totalCurrentNumberOfBMPType) {
        this.totalCurrentNumberOfBMPType = totalCurrentNumberOfBMPType;
    }

    public void setTotalCurrentNumberOfMDBType(int totalCurrentNumberOfMDBType) {
        this.totalCurrentNumberOfMDBType = totalCurrentNumberOfMDBType;
    }

    public void setTotalCurrentNumberOfSBLType(int totalCurrentNumberOfSBLType) {
        this.totalCurrentNumberOfSBLType = totalCurrentNumberOfSBLType;
    }

    public void setTotalCurrentNumberOfBeanType(int totalCurrentNumberOfBeanType) {
        this.totalCurrentNumberOfBeanType = totalCurrentNumberOfBeanType;
    }

    public boolean getMonitoringEnabled() {
        return monitoringEnabled;
    }

    public void setMonitoringEnabled(boolean monitoringEnabled) {
        this.monitoringEnabled = monitoringEnabled;
    }

    public int getWarningThreshold() {
        return warningThreshold;
    }

    public void setWarningThreshold(int warningThreshold) {
        this.warningThreshold = warningThreshold;
    }

    public String getApplySettingsTo() {
        return applySettingsTo;
    }

    public void setApplySettingsTo(String applySettingsTo) {
        this.applySettingsTo = applySettingsTo;
    }
    
    public List getBooleanValues() {
        return Jlists.getBooleanValues();
    }

    public int getNumberOfCalls() {
        return numberOfCalls;
    }

    public void setNumberOfCalls(int numberOfCalls) {
        this.numberOfCalls = numberOfCalls;
    }

    public long getTotalBusinessProcessingTime() {
        return totalBusinessProcessingTime;
    }

    public void setTotalBusinessProcessingTime(long totalBusinessProcessingTime) {
        this.totalBusinessProcessingTime = totalBusinessProcessingTime;
    }

    public long getTotalProcessingTime() {
        return totalProcessingTime;
    }

    public void setTotalProcessingTime(long totalProcessingTime) {
        this.totalProcessingTime = totalProcessingTime;
    }

    public long getAverageBusinessProcessingTime() {
        return averageBusinessProcessingTime;
    }

    public void setAverageBusinessProcessingTime(long averageBusinessProcessingTime) {
        this.averageBusinessProcessingTime = averageBusinessProcessingTime;
    }

    public long getAverageProcessingTime() {
        return averageProcessingTime;
    }

    public void setAverageProcessingTime(long averageProcessingTime) {
        this.averageProcessingTime = averageProcessingTime;
    }

    public boolean isMonitoringSettingsDefinedInDD() {
        return monitoringSettingsDefinedInDD;
    }

    public void setMonitoringSettingsDefinedInDD(boolean monitoringSettingsDefinedInDD) {
        this.monitoringSettingsDefinedInDD = monitoringSettingsDefinedInDD;
    }
}